=== debian/changelog ===
bowtie2 (2.5.5-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * Adjusted patches.

  [ Andreas Tille ]
  * d/watch: version=5

 -- Steffen Moeller <moeller@debian.org>  Sun, 22 Feb 2026 15:11:39 +0000
