=== debian/watch ===
Version: 5

Template: Github
Owner: BenLangmead
Project: bowtie2
